com.google.appengine.api.datastore

## Class CloudDatastoreRemoteServiceConfig.Builder

- java.lang.Object
- - com.google.appengine.api.datastore.CloudDatastoreRemoteServiceConfig.Builder

- Enclosing class:
    CloudDatastoreRemoteServiceConfig

      public abstract static class CloudDatastoreRemoteServiceConfig.Builder
      extends java.lang.Object

  Builder for `CloudDatastoreRemoteServiceConfig`.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Builder()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract CloudDatastoreRemoteServiceConfig.Builder` | `additionalAppIds(java.util.Set<CloudDatastoreRemoteServiceConfig.AppId> value)` Provides a set of additional app IDs that may appear in `Key` values in entities.
    `abstract CloudDatastoreRemoteServiceConfig.Builder` | `appId(CloudDatastoreRemoteServiceConfig.AppId value)` Sets the `CloudDatastoreRemoteServiceConfig.AppId` of the Cloud Datastore instance to call.
    `abstract CloudDatastoreRemoteServiceConfig.Builder` | `asyncStackTraceCaptureEnabled(boolean value)` If set to true, stacktrace for async calls is captured and returned as part of error messages.
    `CloudDatastoreRemoteServiceConfig` | `build()`
    `abstract CloudDatastoreRemoteServiceConfig.Builder` | `emulatorHost(java.lang.String value)` Instructs the client to connect to a locally-running Cloud Datastore Emulator and not to pass credentials.
    `abstract CloudDatastoreRemoteServiceConfig.Builder` | `hostOverride(java.lang.String value)` Overrides the host (e.g.
    `abstract CloudDatastoreRemoteServiceConfig.Builder` | `httpConnectTimeoutMillis(int value)` Sets the HTTP connect timeout in milliseconds.
    `abstract CloudDatastoreRemoteServiceConfig.Builder` | `installApiProxyEnvironment(boolean value)` If set to true, a minimal `ApiProxy.Environment` will be installed (if none is already installed).
    `abstract CloudDatastoreRemoteServiceConfig.Builder` | `maxRetries(int value)` Sets the maximum number of retries for underlying HTTP connect exceptions.
    `abstract CloudDatastoreRemoteServiceConfig.Builder` | `useComputeEngineCredential(boolean value)` If set to true, always use a Compute Engine credential instead of using the Application Default Credentials library to construct the credential.
    `CloudDatastoreRemoteServiceConfig.Builder` | `useServiceAccountCredential(java.lang.String serviceAccountId, java.security.PrivateKey privateKey)` Instructs the client to use a service account credential instead of using the Application Default Credentials library to construct the credential.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Builder

          public Builder()

  - ### Method Detail

    - #### appId

          public abstract CloudDatastoreRemoteServiceConfig.Builder appId(CloudDatastoreRemoteServiceConfig.AppId value)

      Sets the `CloudDatastoreRemoteServiceConfig.AppId` of the Cloud Datastore instance to call. Required.

    - #### emulatorHost

          public abstract CloudDatastoreRemoteServiceConfig.Builder emulatorHost(java.lang.String value)

      Instructs the client to connect to a locally-running Cloud Datastore Emulator and not to pass credentials.

    - #### hostOverride

          public abstract CloudDatastoreRemoteServiceConfig.Builder hostOverride(java.lang.String value)

      Overrides the host (e.g. `datastore.googleapis.com`) used to contact the Cloud Datastore API. To connect to the Cloud Datastore Emulator, use `emulatorHost(java.lang.String)` instead.

    - #### additionalAppIds

          public abstract CloudDatastoreRemoteServiceConfig.Builder additionalAppIds(java.util.Set<CloudDatastoreRemoteServiceConfig.AppId> value)

      Provides a set of additional app IDs that may appear in `Key` values in entities.

      This is only required if the client will read entities containing `Key` values that contain app IDs other than the one provided to `appId(com.google.appengine.api.datastore.CloudDatastoreRemoteServiceConfig.AppId)`. Any such app IDs should be provided to this method.

    - #### installApiProxyEnvironment

          public abstract CloudDatastoreRemoteServiceConfig.Builder installApiProxyEnvironment(boolean value)

      If set to true, a minimal `ApiProxy.Environment` will be installed (if none is already installed).

      If set to false, no attempt to install an environment will be made and the user must install it instead. At a minimum, such an environment must provide implementations for `ApiProxy.Environment.getAppId()`, `ApiProxy.Environment.getAttributes()`, and `ApiProxy.Environment.getRemainingMillis()`.

    - #### useComputeEngineCredential

          public abstract CloudDatastoreRemoteServiceConfig.Builder useComputeEngineCredential(boolean value)

      If set to true, always use a Compute Engine credential instead of using the Application Default Credentials library to construct the credential.

      Cannot be combined with a call to `useServiceAccountCredential(String, PrivateKey)`.

    - #### maxRetries

          public abstract CloudDatastoreRemoteServiceConfig.Builder maxRetries(int value)

      Sets the maximum number of retries for underlying HTTP connect exceptions.

    - #### httpConnectTimeoutMillis

          public abstract CloudDatastoreRemoteServiceConfig.Builder httpConnectTimeoutMillis(int value)

      Sets the HTTP connect timeout in milliseconds.

    - #### asyncStackTraceCaptureEnabled

          public abstract CloudDatastoreRemoteServiceConfig.Builder asyncStackTraceCaptureEnabled(boolean value)

      If set to true, stacktrace for async calls is captured and returned as part of error messages. There is overhead in capturing this stack trace and it is recommended to enable it primarily for debugging.

    - #### useServiceAccountCredential

          public CloudDatastoreRemoteServiceConfig.Builder useServiceAccountCredential(java.lang.String serviceAccountId,
                                                                                       java.security.PrivateKey privateKey)

      Instructs the client to use a service account credential instead of using the Application Default Credentials library to construct the credential.

      Cannot be combined with a call to `useComputeEngineCredential(boolean)`.

    - #### build

          public CloudDatastoreRemoteServiceConfig build()